USE Weather

DELIMITER $$

CREATE PROCEDURE Reconcile_HighsLows(IN nYMD INTEGER(8))
MODIFIES SQL DATA
BEGIN

DECLARE RETvpID TINYINT;
DECLARE NoMore BOOLEAN;

DECLARE CURvpID CURSOR FOR
    SELECT vpID FROM Location;

DECLARE CONTINUE HANDLER FOR NOT FOUND
    SET NoMore = TRUE; 

SET NoMORE = FALSE;

OPEN CURvpID;

doLoop: LOOP
    FETCH CURvpID INTO RETvpID;
    IF NoMore THEN
        CLOSE CURvpID;
        LEAVE doLoop;
    END IF;

    SELECT 'Barometer_HL_RCL', RETvpID, nYMD;
    CALL Barometer_HL_RCL(nYMD,RETvpID);
    SHOW WARNINGS;

    SELECT 'Hourly_HL_RCL', RETvpID, nYMD;
    CALL Hourly_HL_RCL(nYMD,RETvpID);
    SHOW WARNINGS;

    SELECT 'Humidity_HL_RCL', RETvpID, nYMD;
    CALL Humidity_HL_RCL(nYMD,RETvpID);
    SHOW WARNINGS;

    SELECT 'Rain_HL_RCL', RETvpID, nYMD;
    CALL Rain_HL_RCL(nYMD,RETvpID);
    SHOW WARNINGS;

    SELECT 'Solar_HL_RCL', RETvpID, nYMD;
    CALL Solar_HL_RCL(nYMD,RETvpID);
    SHOW WARNINGS;

    SELECT 'Temperature_HL_RCL', RETvpID, nYMD;
    CALL Temperature_HL_RCL(nYMD,RETvpID);
    SHOW WARNINGS;

    SELECT 'Wind_HL_RCL', RETvpID, nYMD;
    CALL Wind_HL_RCL(nYMD,RETvpID);
    SHOW WARNINGS;

END LOOP doLoop;

END$$


CREATE TRIGGER onDTinsert AFTER INSERT ON DT
FOR EACH ROW
BEGIN
    INSERT IGNORE INTO YMD (YearMonthDay, YearMonth, bDate, bYear, bMonth, bDay, vpID) VALUES (CONCAT(NEW.bYear, NEW.bMonth, NEW.bDay), CONCAT(NEW.bYear, NEW.bMonth), NEW.bDate, NEW.bYear, NEW.bMonth, NEW.bDay, NEW.vpID);
END$$

CREATE TRIGGER onYMDinsert AFTER INSERT ON YMD
FOR EACH ROW
BEGIN
    INSERT INTO DHL (YearMonthDay, YearMonth, bDate, bYear, bMonth, bDay, vpID) VALUES (CONCAT(NEW.bYear, NEW.bMonth, NEW.bDay), CONCAT(NEW.bYear, NEW.bMonth), NEW.bDate, NEW.bYear, NEW.bMonth, NEW.bDay, NEW.vpID);
END$$

CREATE TRIGGER onDHLnsert AFTER INSERT ON DHL
FOR EACH ROW
BEGIN
    INSERT IGNORE INTO MHL (YearMonth, bYear, bMonth, vpID) VALUES (CONCAT(NEW.bYear, NEW.bMonth), NEW.bYear, NEW.bMonth, NEW.vpID);
END$$

CREATE TRIGGER onMHLnsert AFTER INSERT ON MHL
FOR EACH ROW
BEGIN
    INSERT IGNORE INTO YHL (bYear, vpID) VALUES (NEW.bYear, NEW.vpID);
END$$

DELIMITER ;

