USE Weather

DELIMITER $$

CREATE PROCEDURE MHL_UPD(IN NewY SMALLINT, NewvpID TINYINT, NewTHSWHigh INTEGER, NewTHSWHighDT DATETIME, NewUVHigh INTEGER, NewUVHighDT DATETIME, NewDewPointHigh INTEGER, NewDewPointHighDT DATETIME, NewDewPointLow INTEGER, NewDewPointLowDT DATETIME, NewF CHAR(1))
MODIFIES SQL DATA
BEGIN

DECLARE curMaxTHSW INTEGER(3);
DECLARE curMaxTHSWDT DATETIME;
DECLARE maxTHSW INTEGER(3);
DECLARE maxTHSWDT DATETIME;

DECLARE curMaxUV INTEGER(3);
DECLARE curMaxUVDT DATETIME;
DECLARE maxUV INTEGER(3);
DECLARE maxUVDT DATETIME;

DECLARE curMaxDewPoint INTEGER(3);
DECLARE curMaxDewPointDT DATETIME;
DECLARE maxDewPoint INTEGER(3);
DECLARE maxDewPointDT DATETIME;

DECLARE curMinDewPoint INTEGER(3);
DECLARE curMinDewPointDT DATETIME;
DECLARE minDewPoint INTEGER(3);
DECLARE minDewPointDT DATETIME;

SELECT THSWHigh, THSWHighDT, UVHigh, UVHighDT, DewPointHigh, DewPointHighDT, DewPointLow, DewPointLowDT INTO curMaxTHSW, curMaxTHSWDT, curMaxUV, curMaxUVDT, curMaxDewPoint, curMaxDewPointDT, curMinDewPoint, curMinDewPointDT FROM YHL USE INDEX (PRIMARY) WHERE bYear = NewY && vpID = Newvpid;

IF NewTHSWHigh IS NOT NULL && (NewTHSWHigh > curMaxTHSW || curMaxTHSW IS NULL) THEN
    UPDATE YHL SET THSWHigh = NewTHSWHigh, F = NewF WHERE bYear = NewY && vpID = Newvpid;
END IF;

IF NewTHSWHighDT IS NOT NULL THEN
    SELECT max(THSWHigh) INTO maxTHSW FROM MHL USE INDEX (YvpID) WHERE bYear = NewY && vpID = Newvpid;
    SELECT THSWHighDT INTO maxTHSWDT FROM MHL USE INDEX (YvpID) WHERE bYear = NewY && vpID = Newvpid && THSWHigh = maxTHSW LIMIT 1;
    IF maxTHSW != curMaxTHSW THEN
        UPDATE YHL SET THSWHigh = maxTHSW, F = NewF WHERE bYear = NewY && vpID = Newvpid;
    END IF;
    IF maxTHSWDT != curMaxTHSWDT || curMaxTHSWDT IS NULL THEN
        UPDATE YHL SET THSWHighDT = maxTHSWDT, F = NewF WHERE bYear = NewY && vpID = Newvpid;
    END IF;
END IF;

IF NewUVHigh IS NOT NULL && (NewUVHigh > curMaxUV || curMaxUV IS NULL) THEN
    UPDATE YHL SET UVHigh = NewUVHigh, F = NewF WHERE bYear = NewY && vpID = Newvpid;
END IF;

IF NewUVHighDT IS NOT NULL THEN
    SELECT max(UVHigh) INTO maxUV FROM MHL USE INDEX (YvpID) WHERE bYear = NewY && vpID = Newvpid;
    SELECT UVHighDT INTO maxUVDT FROM MHL USE INDEX (YvpID) WHERE bYear = NewY && vpID = Newvpid && UVHigh = maxUV LIMIT 1;
    IF maxUV != curMaxUV THEN
        UPDATE YHL SET UVHigh = maxUV, F = NewF WHERE bYear = NewY && vpID = Newvpid;
    END IF;
    IF maxUVDT != curMaxUVDT || curMaxUVDT IS NULL THEN
        UPDATE YHL SET UVHighDT = maxUVDT, F = NewF WHERE bYear = NewY && vpID = Newvpid;
    END IF;
END IF;

IF NewDewPointHigh IS NOT NULL && (NewDewPointHigh > curMaxDewPoint || curMaxDewPoint IS NULL) THEN
    UPDATE YHL SET DewPointHigh = NewDewPointHigh, F = NewF WHERE bYear = NewY && vpID = Newvpid;
END IF;

IF NewDewPointHighDT IS NOT NULL THEN
    SELECT max(DewPointHigh) INTO maxDewPoint FROM MHL USE INDEX (YvpID) WHERE bYear = NewY && vpID = Newvpid;
    SELECT DewPointHighDT INTO maxDewPointDT FROM MHL USE INDEX (YvpID) WHERE bYear = NewY && vpID = Newvpid && DewPointHigh = maxDewPoint LIMIT 1;
    IF maxDewPoint != curMaxDewPoint THEN
        UPDATE YHL SET DewPointHigh = maxDewPoint, F = NewF WHERE bYear = NewY && vpID = Newvpid;
    END IF;
    IF maxDewPointDT != curMaxDewPointDT || curMaxDewPointDT IS NULL THEN
        UPDATE YHL SET DewPointHighDT = maxDewPointDT, F = NewF WHERE bYear = NewY && vpID = Newvpid;
    END IF;
END IF;

IF NewDewPointLow IS NOT NULL && (NewDewPointLow < curMinDewPoint || curMinDewPoint IS NULL) THEN
    UPDATE YHL SET DewPointLow = NewDewPointLow, F = NewF WHERE bYear = NewY && vpID = Newvpid;
END IF;

IF NewDewPointLowDT IS NOT NULL THEN
    SELECT min(DewPointLow) INTO minDewPoint FROM MHL USE INDEX (YvpID) WHERE bYear = NewY && vpID = Newvpid;
    SELECT DewPointLowDT INTO minDewPointDT FROM MHL USE INDEX (YvpID) WHERE bYear = NewY && vpID = Newvpid && DewPointLow = minDewPoint LIMIT 1;
    IF minDewPoint != curMinDewPoint THEN
        UPDATE YHL SET DewPointLow = minDewPoint, F = NewF WHERE bYear = NewY;
    END IF;
    if (minDewPointDT != curMinDewPointDT || curMinDewPointDT IS NULL) THEN
        UPDATE YHL SET DewPointLowDT = minDewPointDT, F = NewF WHERE bYear = NewY && vpID = Newvpid;
    END IF;
END IF;

END$$

CREATE TRIGGER MHL_UPD AFTER UPDATE ON MHL
FOR EACH ROW
BEGIN
CALL MHL_UPD(NEW.bYear,NEW.vpID,NEW.THSWHigh,NEW.THSWHighDT,NEW.UVHigh,NEW.UVHighDT,NEW.DewPointHigh,NEW.DewPointHighDT,NEW.DewPointLow,NEW.DewPointLowDT,NEW.F);
END$$

DELIMITER ;

