USE Weather

DELIMITER $$

CREATE PROCEDURE Temperature_HL_UPD(IN nRecID BIGINT, NewOutdoor DECIMAL(6,1), NewIndoor DECIMAL(6,1), NewWindChill DECIMAL(6,1), NewHeatIndex DECIMAL(6,1), NewF CHAR(1))
MODIFIES SQL DATA
BEGIN

DECLARE INSdatetime DATETIME;
DECLARE INSdate DATE;
DECLARE INSymd INTEGER(8);
DECLARE INSym INTEGER(6);
DECLARE INSy SMALLINT(4);
DECLARE INSm SMALLINT(2);
DECLARE INSvpID TINYINT;

DECLARE maxOutTemp DECIMAL(6,1);
DECLARE minOutTemp DECIMAL(6,1);

DECLARE maxInTemp DECIMAL(6,1);
DECLARE minInTemp DECIMAL(6,1);

DECLARE minWindChill DECIMAL(6,1);
DECLARE maxHeatIndex DECIMAL(6,1);

SELECT bDateTime, bDate, YearMonthDay, YearMonth, bYear, bMonth, vpID INTO INSdatetime, INSdate, INSymd, INSym, INSy, INSm, INSvpID FROM DT USE INDEX (RecID) WHERE RecID = nRecID;

SELECT OutTempHigh, OutTempLow, InTempHigh, InTempLow, WindChillLow, HeatIndexHigh, F INTO maxOutTemp, minOutTemp, maxInTemp, minInTemp, minWindChill, maxHeatIndex, NewF FROM DHL USE INDEX (PRIMARY) WHERE YearMonthDay = INSymd && vpID = INSvpID;

IF NewOutdoor IS NOT NULL && (NewOutdoor > maxOutTemp || maxOutTemp IS NULL) THEN
    UPDATE DHL SET OutTempHigh = NewOutdoor, OutTempHighDT = INSdatetime, F = NewF WHERE YearMonthDay = INSymd && vpID = INSvpID;
END IF;

IF NewOutdoor IS NOT NULL && (NewOutdoor < minOutTemp || minOutTemp IS NULL) THEN
    UPDATE DHL SET OutTempLow = NewOutdoor, OutTempLowDT = INSdatetime, F = NewF WHERE YearMonthDay = INSymd && vpID = INSvpID;
END IF;

IF NewIndoor IS NOT NULL && (NewIndoor > maxInTemp || maxInTemp IS NULL) THEN
    UPDATE DHL SET InTempHigh = NewIndoor, InTempHighDT = INSdatetime, F = NewF WHERE YearMonthDay = INSymd && vpID = INSvpID;
END IF;

IF NewIndoor IS NOT NULL && (NewIndoor < minInTemp || minInTemp IS NULL) THEN
    UPDATE DHL SET InTempLow = NewIndoor, InTempLowDT = INSdatetime, F = NewF WHERE YearMonthDay = INSymd && vpID = INSvpID;
END IF;

IF NewWindChill IS NOT NULL && (NewWindChill < minWindChill || minWindChill IS NULL) THEN
    UPDATE DHL SET WindChillLow = NewWindChill, WindChillLowDT = INSdatetime, F = NewF WHERE YearMonthDay = INSymd && vpID = INSvpID;
END IF;

IF NewHeatIndex IS NOT NULL && (NewHeatIndex > maxHeatIndex || maxInTemp IS NULL) THEN
    UPDATE DHL SET HeatIndexHigh = NewHeatIndex, HeatIndexHighDT = INSdatetime, F = NewF WHERE YearMonthDay = INSymd && vpID = INSvpID;
END IF;

SELECT OutTempHigh, OutTempLow, InTempHigh, InTempLow, WindChillLow, HeatIndexHigh INTO maxOutTemp, minOutTemp, maxInTemp, minInTemp, minWindChill, maxHeatIndex FROM MHL USE INDEX (PRIMARY) WHERE YearMonth = INSym && vpID = INSvpID;

IF NewOutdoor IS NOT NULL && (NewOutdoor > maxOutTemp || maxOutTemp IS NULL) THEN
    UPDATE MHL SET OutTempHigh = NewOutdoor, OutTempHighDT = INSdatetime, F = NewF WHERE YearMonth = INSym && vpID = INSvpID;
END IF;

IF NewOutdoor IS NOT NULL && (NewOutdoor < minOutTemp || minOutTemp IS NULL) THEN
    UPDATE MHL SET OutTempLow = NewOutdoor, OutTempLowDT = INSdatetime, F = NewF WHERE YearMonth = INSym && vpID = INSvpID;
END IF;

IF NewIndoor IS NOT NULL && (NewIndoor > maxInTemp || maxInTemp IS NULL) THEN
    UPDATE MHL SET InTempHigh = NewIndoor, InTempHighDT = INSdatetime, F = NewF WHERE YearMonth = INSym && vpID = INSvpID;
END IF;

IF NewIndoor IS NOT NULL && (NewIndoor < minInTemp || minInTemp IS NULL) THEN
    UPDATE MHL SET InTempLow = NewIndoor, InTempLowDT = INSdatetime, F = NewF WHERE YearMonth = INSym && vpID = INSvpID;
END IF;

IF NewWindChill IS NOT NULL && (NewWindChill < minWindChill || minWindChill IS NULL) THEN
    UPDATE MHL SET WindChillLow = NewWindChill, WindChillLowDT = INSdatetime, F = NewF WHERE YearMonth = INSym && vpID = INSvpID;
END IF;

IF NewHeatIndex IS NOT NULL && (NewHeatIndex > maxHeatIndex || maxInTemp IS NULL) THEN
    UPDATE MHL SET HeatIndexHigh = NewHeatIndex, HeatIndexHighDT = INSdatetime, F = NewF WHERE YearMonth = INSym && vpID = INSvpID;
END IF;

SELECT OutTempHigh, OutTempLow, InTempHigh, InTempLow, WindChillLow, HeatIndexHigh INTO maxOutTemp, minOutTemp, maxInTemp, minInTemp, minWindChill, maxHeatIndex FROM YHL USE INDEX (PRIMARY) WHERE bYear = INSy && vpID = INSvpID;

IF NewOutdoor IS NOT NULL && (NewOutdoor > maxOutTemp || maxOutTemp IS NULL) THEN
    UPDATE YHL SET OutTempHigh = NewOutdoor, OutTempHighDT = INSdatetime, F = NewF WHERE bYear = INSy && vpID = INSvpID;
END IF;

IF NewOutdoor IS NOT NULL && (NewOutdoor < minOutTemp || minOutTemp IS NULL) THEN
    UPDATE YHL SET OutTempLow = NewOutdoor, OutTempLowDT = INSdatetime, F = NewF WHERE bYear = INSy && vpID = INSvpID;
END IF;

IF NewIndoor IS NOT NULL && (NewIndoor > maxInTemp || maxInTemp IS NULL) THEN
    UPDATE YHL SET InTempHigh = NewIndoor, InTempHighDT = INSdatetime, F = NewF WHERE bYear = INSy && vpID = INSvpID;
END IF;

IF NewIndoor IS NOT NULL && (NewIndoor < minInTemp || minInTemp IS NULL) THEN
    UPDATE YHL SET InTempLow = NewIndoor, InTempLowDT = INSdatetime, F = NewF WHERE bYear = INSy && vpID = INSvpID;
END IF;

IF NewWindChill IS NOT NULL && (NewWindChill < minWindChill || minWindChill IS NULL) THEN
    UPDATE YHL SET WindChillLow = NewWindChill, WindChillLowDT = INSdatetime, F = NewF WHERE bYear = INSy && vpID = INSvpID;
END IF;

IF NewHeatIndex IS NOT NULL && (NewHeatIndex > maxHeatIndex || maxHeatIndex IS NULL) THEN
    UPDATE YHL SET HeatIndexHigh = NewHeatIndex, HeatIndexHighDT = INSdatetime, F = NewF WHERE bYear = INSy && vpID = INSvpID;
END IF;

END$$

CREATE PROCEDURE Temperature_HL_SET(IN nRecID BIGINT)
MODIFIES SQL DATA
BEGIN

DECLARE INSdate DATE;
DECLARE INSymd INTEGER(8);
DECLARE INSym INTEGER(6);
DECLARE INSy SMALLINT(4);
DECLARE INSm SMALLINT(2);
DECLARE INSvpID TINYINT;

DECLARE maxOutTemp DECIMAL(6,1);
DECLARE maxOutTempDT DATETIME;
DECLARE minOutTemp DECIMAL(6,1);
DECLARE minOutTempDT DATETIME;

DECLARE maxInTemp DECIMAL(6,1);
DECLARE maxInTempDT DATETIME;
DECLARE minInTemp DECIMAL(6,1);
DECLARE minInTempDT DATETIME;

DECLARE minWindChill DECIMAL(6,1);
DECLARE minWindChillDT DATETIME;

DECLARE maxHeatIndex DECIMAL(6,1);
DECLARE maxHeatIndexDT DATETIME;

DECLARE curF CHAR(1);

SELECT bDate, YearMonthDay, YearMonth, bYear, bMonth, vpID INTO INSdate, INSymd, INSym, INSy, INSm, INSvpID FROM DT USE INDEX (RecID) WHERE RecID = nRecID;

SELECT F INTO curF FROM Temperature USE INDEX (PRIMARY) WHERE RecID = nRecID;

SELECT max(t1.Outdoor), min(t1.Outdoor), max(t1.Indoor), min(t1.Indoor), min(t1.WindChill), max(t1.HeatIndex) INTO maxOutTemp, minOutTemp, maxInTemp, minInTemp, minWindChill, maxHeatIndex FROM Temperature AS t1 INNER JOIN DT AS t2 USE INDEX (YMDvpID) USING (RecID) WHERE t2.YearMonthDay = INSymd && t2.vpID = INSvpID;

SELECT t2.bDateTime INTO maxOutTempDT FROM Temperature AS t1 INNER JOIN DT AS t2 USE INDEX (YMDvpID) USING (RecID) WHERE t1.Outdoor = maxOutTemp && t2.YearMonthDay = INSymd && t2.vpID = INSvpID ORDER BY t2.bDateTime LIMIT 1;

SELECT t2.bDateTime INTO minOutTempDT FROM Temperature AS t1 INNER JOIN DT AS t2 USE INDEX (YMDvpID) USING (RecID) WHERE t1.Outdoor = minOutTemp && t2.YearMonthDay = INSymd && t2.vpID = INSvpID ORDER BY t2.bDateTime LIMIT 1;

SELECT t2.bDateTime INTO maxInTempDT FROM Temperature AS t1 INNER JOIN DT AS t2 USE INDEX (YMDvpID) USING (RecID) WHERE t1.Indoor = maxInTemp && t2.YearMonthDay = INSymd && t2.vpID = INSvpID ORDER BY t2.bDateTime LIMIT 1;

SELECT t2.bDateTime INTO minInTempDT FROM Temperature AS t1 INNER JOIN DT AS t2 USE INDEX (YMDvpID) USING (RecID) WHERE t1.Indoor = minInTemp && t2.YearMonthDay = INSymd && t2.vpID = INSvpID ORDER BY t2.bDateTime LIMIT 1;

SELECT t2.bDateTime INTO minWindChillDT FROM Temperature AS t1 INNER JOIN DT AS t2 USE INDEX (YMDvpID) USING (RecID) WHERE t1.WindChill = minWindChill && t2.YearMonthDay = INSymd && t2.vpID = INSvpID ORDER BY t2.bDateTime LIMIT 1;

SELECT t2.bDateTime INTO maxHeatIndexDT FROM Temperature AS t1 INNER JOIN DT AS t2 USE INDEX (YMDvpID) USING (RecID) WHERE t1.HeatIndex = maxHeatIndex && t2.YearMonthDay = INSymd && t2.vpID = INSvpID ORDER BY t2.bDateTime LIMIT 1;

UPDATE DHL SET OutTempHigh = maxOutTemp, OutTempHighDT = maxOutTempDT, OutTempLow = minOutTemp, OutTempLowDT = minOutTempDT, InTempHigh = maxInTemp, InTempHighDT = maxInTempDT, InTempLow = minInTemp, InTempLowDT = minInTempDT, WindChillLow = minWindChill, WindChillLowDT = minWindChillDT, HeatIndexHigh = maxHeatIndex, HeatIndexHighDT = maxHeatIndexDT, F = curF WHERE YearMonthDay = INSymd && vpID = INSvpID;

SELECT max(OutTempHigh), min(OutTempLow), max(InTempHigh), min(InTempLow), min(WindChillLow), max(HeatIndexHigh) INTO maxOutTemp, minOutTemp, maxInTemp, minInTemp, minWindChill, maxHeatIndex FROM DHL USE INDEX (YMvpID) WHERE YearMonth = INSym && vpID = INSvpID;

SELECT OutTempHighDT INTO maxOutTempDT FROM DHL USE INDEX (YMvpID) WHERE OutTempHigh = maxOutTemp && YearMonth = INSym && vpID = INSvpID LIMIT 1;

SELECT OutTempLowDT INTO minOutTempDT FROM DHL USE INDEX (YMvpID) WHERE OutTempLow = minOutTemp && YearMonth = INSym && vpID = INSvpID LIMIT 1;

SELECT InTempHighDT INTO maxInTempDT FROM DHL USE INDEX (YMvpID) WHERE InTempHigh = maxInTemp && YearMonth = INSym && vpID = INSvpID LIMIT 1;

SELECT InTempLowDT INTO minInTempDT FROM DHL USE INDEX (YMvpID) WHERE InTempLow = minInTemp && YearMonth = INSym && vpID = INSvpID LIMIT 1;

SELECT WindChillLowDT INTO minWindChillDT FROM DHL USE INDEX (YMvpID) WHERE WindChillLow = minWindChill && YearMonth = INSym && vpID = INSvpID LIMIT 1;

SELECT HeatIndexHighDT INTO maxHeatIndexDT FROM DHL USE INDEX (YMvpID) WHERE HeatIndexHigh = maxHeatIndex && YearMonth = INSym && vpID = INSvpID LIMIT 1;

UPDATE MHL SET OutTempHigh = maxOutTemp, OutTempHighDT = maxOutTempDT, OutTempLow = minOutTemp, OutTempLowDT = minOutTempDT, InTempHigh = maxInTemp, InTempHighDT = maxInTempDT, InTempLow = minInTemp, InTempLowDT = minInTempDT, WindChillLow = minWindChill, WindChillLowDT = minWindChillDT, HeatIndexHigh = maxHeatIndex, HeatIndexHighDT = maxHeatIndexDT, F = curF WHERE YearMonth = INSym && vpID = INSvpID;

SELECT max(OutTempHigh), min(OutTempLow), max(InTempHigh), min(InTempLow), min(WindChillLow), max(HeatIndexHigh) INTO maxOutTemp, minOutTemp, maxInTemp, minInTemp, minWindChill, maxHeatIndex FROM MHL USE INDEX (YvpID) WHERE bYear = INSy && vpID = INSvpID;

SELECT OutTempHighDT INTO maxOutTempDT FROM MHL USE INDEX (YvpID) WHERE OutTempHigh = maxOutTemp && bYear = INSy && vpID = INSvpID LIMIT 1;

SELECT OutTempLowDT INTO minOutTempDT FROM MHL USE INDEX (YvpID) WHERE OutTempLow = minOutTemp && bYear = INSy && vpID = INSvpID LIMIT 1;

SELECT InTempHighDT INTO maxInTempDT FROM MHL USE INDEX (YvpID) WHERE InTempHigh = maxInTemp && bYear = INSy && vpID = INSvpID LIMIT 1;

SELECT InTempLowDT INTO minInTempDT FROM MHL USE INDEX (YvpID) WHERE InTempLow = minInTemp && bYear = INSy && vpID = INSvpID LIMIT 1;

SELECT WindChillLowDT INTO minWindChillDT FROM MHL USE INDEX (YvpID) WHERE WindChillLow = minWindChill && bYear = INSy && vpID = INSvpID LIMIT 1;

SELECT HeatIndexHighDT INTO maxHeatIndexDT FROM MHL USE INDEX (YvpID) WHERE HeatIndexHigh = maxHeatIndex && bYear = INSy && vpID = INSvpID LIMIT 1;

UPDATE YHL SET OutTempHigh = maxOutTemp, OutTempHighDT = maxOutTempDT, OutTempLow = minOutTemp, OutTempLowDT = minOutTempDT, InTempHigh = maxInTemp, InTempHighDT = maxInTempDT, InTempLow = minInTemp, InTempLowDT = minInTempDT, WindChillLow = minWindChill, WindChillLowDT = minWindChillDT, HeatIndexHigh = maxHeatIndex, HeatIndexHighDT = maxHeatIndexDT, F = curF WHERE bYear = INSy && vpID = INSvpID;

END$$

CREATE PROCEDURE Temperature_HL_RCL(IN nYMD INTEGER(8), nvpID TINYINT)
MODIFIES SQL DATA
BEGIN

DECLARE dRecID BIGINT;
DECLARE INSdate DATE;
DECLARE INSymd INTEGER(8);
DECLARE INSym INTEGER(6);
DECLARE INSy SMALLINT(4);
DECLARE INSm SMALLINT(2);
DECLARE INSd SMALLINT(2);
DECLARE dYMD INTEGER(8);

SELECT RecID, bDate, YearMonthDay, YearMonth, bYear, bMonth, bDay INTO dRecID, INSdate, INSymd, INSym, INSy, INSm, INSd FROM DT USE INDEX (YMDvpID) WHERE YearMonthDay = nYMD && vpID = nvpID LIMIT 1;

IF dRecID IS NOT NULL && dRecID > 0 THEN
    SELECT YearMonthDay INTO dYMD FROM YMD USE INDEX (PRIMARY) WHERE YearMonthDay = nYMD && vpID = nvpID LIMIT 1;
    IF dYMD IS NULL THEN
        INSERT IGNORE INTO YMD (YearMonthDay, YearMonth, bDate, bYear, bMonth, bDay, vpID) VALUES (INSymd, INSym, INSdate, INSy, INSm, INSd, nvpID);
    END IF;
    CALL Temperature_HL_SET(dRecID);
END IF;

END$$

CREATE TRIGGER Temperature_INS AFTER INSERT ON Temperature
FOR EACH ROW
BEGIN
CALL Temperature_HL_UPD(NEW.RecID,NEW.Outdoor,NEW.Indoor,NEW.WindChill,NEW.HeatIndex,NEW.F);
END$$

CREATE TRIGGER Temperature_UPD AFTER UPDATE ON Temperature
FOR EACH ROW
BEGIN
CALL Temperature_HL_UPD(NEW.RecID,NEW.Outdoor,NEW.Indoor,NEW.WindChill,NEW.HeatIndex,NEW.F);
END$$

CREATE TRIGGER Temperature_DEL AFTER DELETE ON Temperature
FOR EACH ROW
BEGIN
CALL Temperature_HL_SET(OLD.RecID);
END$$


DELIMITER ;


