USE Weather

CREATE TABLE IF NOT EXISTS VersionWeatherDB (
  Version CHAR(10) NOT NULL DEFAULT "11.1.0",
  PRIMARY KEY(Version)
)
ENGINE = MyISAM
DEFAULT CHARACTER SET = utf8
COLLATE = utf8_unicode_ci;

DESC VersionWeatherDB;

INSERT INTO VersionWeatherDB (Version) VALUES ("11.1.0s");

DESC Rain;

ALTER TABLE Rain ADD COLUMN IncrementalRain DECIMAL(6,2) NULL AFTER CurrentlyRaining;

ALTER TABLE Rain CHANGE COLUMN StormStarted StormStartedDate DATE NULL;

ALTER TABLE Rain ADD INDEX StormAmount (StormAmount);

ALTER TABLE Rain ADD INDEX StormStartedDate (StormStartedDate);

DESC Rain;

DESC Storms;

ALTER TABLE Storms ADD COLUMN StormStartedTime TIME NULL AFTER StormStarted;

ALTER TABLE Storms ADD COLUMN StormEndedTime TIME NULL AFTER StormEnded;

ALTER TABLE Storms CHANGE COLUMN StormStarted StormStartedDate DATE NOT NULL;

ALTER TABLE Storms CHANGE COLUMN StormEnded StormEndedDate DATE NULL;

ALTER TABLE Storms ADD INDEX StormStartedTime (StormStartedTime);

ALTER TABLE Storms ADD INDEX StormEndedDate (StormEndedDate);

ALTER TABLE Storms ADD INDEX StormEndedTime (StormEndedTime);

DESC Storms;

DESC DT;

ALTER TABLE DT ADD INDEX bDate (bDate);

ALTER TABLE DT ADD INDEX bTime (bTime);

ALTER TABLE DT DROP INDEX RecID;

ALTER TABLE DT ADD UNIQUE INDEX RecID (RecID);

DESC DT;

DESC YMD;

ALTER TABLE YMD ADD COLUMN SolarNoon TIME NULL AFTER Sunset;

DESC YMD;

UPDATE VersionWeatherDB SET Version = "11.1.0" WHERE Version = "11.1.0s";

SOURCE  WeatherDB_Upgrade_11.1_to_11.4.sql;

